#ifndef __DEFCONF_H
#include "defconf.h"
#endif
/*
   This file was hacked for kmtar PowerUpKit v3.7
                                    at 1995-03-04.
                                    by tantan SGL00213@niftyserve.or.jp 
*/
/*
 * get_dir() - get list of directory
 */

#ifdef RCSID
static char rcsid[] = "$Header: /circus/cvsroot/tar32_1/Src/SRC/GETDIR.C,v 1.1.1.1 1999/12/19 06:04:25 tsuneo Exp $";
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>
#ifdef	WIN32
    #include <io.h>
	#include <windows.h>
#endif
#if	MSC
#include	<sys/types.h>
#endif

#include "defs.h"
#include "misc.h"
#include "getdir.h"

#ifndef global

typedef struct flist {
	struct flist *next;
	char name[0];
} FLIST;

#endif /* global */

/*
 * list merge sorting
 *	Donald E Knuth, "The Art of Computer Programming",
 *	Vol.3 / Sorting & Searching, pp. 165-166, Algorithm L.
 */
FLIST *sort(FLIST *p)
{
	FLIST xh, yh, *xp, *yp, *x, *y;
	unsigned int n, xn, yn;

	/* L1. Separate list p into 2 lists. */
	xp = &xh;
	yp = &yh;
	while (p != NULL) {
		xp->next = p;
		xp = p;
		p = p->next;
		if (p == NULL)
			break;
		yp->next = p;
		yp = p;
		p = p->next;
	}
	xp->next = NULL;
	yp->next = NULL;
	for (n = 1; yh.next != NULL; n *= 2) {
		/* L2. Begin new pass. */
		xp = &xh;
		yp = &yh;
		x = xp->next;
		y = yp->next;
		xn = yn = n;
		do {
			/* L3. Compare */
			if (strcmp(x->name, y->name) <= 0) {
				/* L4. Advance x. */
				xp->next = x;
				xp = x;
				x = x->next;
				if (--xn != 0 && x != NULL)
					continue;
				/* L5. Complete the sublist. */
				xp->next = y;
				xp = yp;
				do {
					yp = y;
					y = y->next;
				} while (--yn != 0 && y != NULL);
			} else {
				/* L6. Advance y. */
				xp->next = y;
				xp = y;
				y = y->next;
				if (--yn != 0 && y != NULL)
					continue;
				/* L7. Complete the sublist. */
				xp->next = x;
				xp = yp;
				do {
					yp = x;
					x = x->next;
				} while (--xn != 0 && x != NULL);
			}
			xn = yn = n;
			/* L8. End of pass? */
		} while (y != NULL);
		xp->next = x;
		yp->next = NULL;
	}
	return (xh.next);
}



/*
 * Returns list of the directory 'dir'
 */

/*
 * Returns list of the directory 'dir'
 */
global FLIST *get_dir(char *dir)
{
	/* type declared to decipher a directory entry */
#ifdef WIN32
	WIN32_FIND_DATA buf;
	HANDLE hFile;
#else
	struct find_t buf;
	long hFile;
#endif
	char fn[FNAME_BUF];
	int rc;
	FLIST *dp, *fp, *w;
	char *s;

	strcat(addsl(strcpy(fn, dir)), "*.*");
	dp = fp = NULL;
#ifdef	WIN32
	hFile = FindFirstFile(fn, &buf);
	rc = (hFile != INVALID_HANDLE_VALUE) ? TRUE:FALSE;
	for (; rc == TRUE; rc = FindNextFile(hFile, &buf)){
	   if (buf.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY)
	      continue;
	   if ((attri_flag & FILE_ATTRIBUTE_SYSTEM) == 0 &&
		   buf.dwFileAttributes & (FILE_ATTRIBUTE_SYSTEM |FILE_ATTRIBUTE_HIDDEN) )
			continue;
 	   if ((attri_flag & FILE_ATTRIBUTE_ARCHIVE) && !(buf.dwFileAttributes &(FILE_ATTRIBUTE_DIRECTORY|FILE_ATTRIBUTE_ARCHIVE)))
			continue;

		w = (FLIST *)malloc(sizeof(FLIST) + strlen(buf.cFileName) + 1);
		if (w == NULL)
			fatal("getdir", "Out of memory");
		for (s = buf.cFileName; *s; s++) {
			if (iskanji(*s) && iskanji2(s[1])) {
				s++;
			}
		}
		strcpy(w->name, buf.cFileName);
		if (buf.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
#else
	rc = _dos_findfirst(fn,
		_A_NORMAL | _A_RDONLY | _A_HIDDEN | _A_SUBDIR | _A_ARCH,
		&buf);
	for (; rc == 0; rc = _dos_findnext(&buf)) {
		w = (FLIST *)malloc(sizeof(FLIST) + strlen(buf.name) + 1);
		if (w == NULL)
			fatal("getdir", "Out of memory");
		for (s = buf.name; *s; s++) {
			if (iskanji(*s) && iskanji2(s[1])) {
				s++;
/* force to small letter*/
			} else if (isascii(*s) && isupper(*s)) {
				*s = (char)tolower(*s);

			}
		}
		strcpy(w->name, buf.name);
		if (buf.attrib & _A_SUBDIR) {
#endif
			w->next = dp;
			dp = w;
		} else {
			w->next = fp;
			fp = w;
		}
	}
#ifdef WIN32
	if (hFile !=INVALID_HANDLE_VALUE)
		FindClose(hFile);
#endif
	dp = sort(dp);
	fp = sort(fp);
	if (fp == NULL)
		fp = dp;
	else {
		for (w = fp; w->next; w = w->next)
			;
		w->next = dp;
	}
	return (fp);
}



/*
 * Free directory list p
 */
global void free_dir(FLIST *p)
{
	FLIST *q;

	while (p) {
		q = p->next;
		free(p);
		p = q;
	}
}
